/* A Bison parser, made from parser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define YYLSP_NEEDED 1

# define	INT	257
# define	FLOAT	258
# define	ID	259
# define	STRING	260
# define	TYVAR	261
# define	CHAR	262
# define	KW_INT	263
# define	KW_RETURN	264
# define	KW_VOID	265
# define	KW_SKIP	266
# define	KW_BOOL	267
# define	KW_FLOAT	268
# define	KW_IN	269
# define	KW_EXTERN_C	270
# define	KW_STRING	271
# define	KW_FUN	272
# define	KW_IF	273
# define	KW_ELSE	274
# define	KW_WHILE	275
# define	KW_DO	276
# define	KW_FOR	277
# define	KW_CASE	278
# define	KW_SWITCH	279
# define	KW_LET	280
# define	KW_EXPORT_AS	281
# define	KW_STRUCT	282
# define	KW_OPT_STRUCT	283
# define	KW_UNION	284
# define	KW_TYPE	285
# define	KW_TYPEDEF	286
# define	KW_TRUE	287
# define	KW_FALSE	288
# define	KW_OPEN	289
# define	KW_NULL	290
# define	KW_RAISE	291
# define	KW_TRY	292
# define	KW_EXCEPTION	293
# define	KW_BREAK	294
# define	KW_CONTINUE	295
# define	KW_FINALLY	296
# define	KW_WITH	297
# define	KW_SECTION	298
# define	DOUBLECOLON	299
# define	ARROW	300
# define	GE	301
# define	LE	302
# define	EQ	303
# define	NE	304
# define	LTLT	305
# define	GTGT	306
# define	PLUS_PLUS	307
# define	MINUS_MINUS	308
# define	SLASH_EQUAL	309
# define	PLUS_EQUAL	310
# define	MINUS_EQUAL	311
# define	PERCENT_EQUAL	312
# define	STAR_EQUAL	313
# define	AND_AND	314
# define	OR_OR	315
# define	UMINUS	316
# define	APPLICATION	317

#line 13 "parser.y"


#include "parser.h"
#include "support.h"

#include <gont/runtime.h>
#include "cgont/ast.h"
#include "cgont/cast.h"
#include "cgont/list.h"
#include "cgont/std.h"

#define YYPARSE_PARAM parm
#define YYLEX_PARAM parm
#define YYERROR_VERBOSE 1

#define YYDEBUG 1

/* Constants. */
static struct gont_union *none;
static struct gont_union *nil;
static struct gont_string *empty_string;

/* Used by impl: rule and parse routine. */
static struct gont_union *decls;

/* Defined in support.c. */
extern struct gont_string *input_filename;
struct GontS_Ast__location *make_location(YYLTYPE *l);
void yyerror(const char *msg);

#define make_expr(raw, l) Cast$$make_expr(raw, make_location(l))
#define make_tyvar Cast$$make_tyvar
#define make_located(d, l) Cast$$make_located(d, make_location(l))
#define make_ref_record(x) Cast$$make_ref_record(x)
#define make_vardef(t, n) Cast$$make_vardef(t, n)
#define make_field(t, n) Cast$$make_field(t, n, make_location(&yyloc))
#define make_tydef(name, vars, ty) \
	Cast$$make_tydef(name, vars, ty, make_location(&yyloc))
#define make_fn_decl(header, exportas, body) \
	Cast$$make_fn_decl(header, exportas, body)
#define bare_fn_type(r, a) Cast$$bare_fn_type(r, a)
#define make_vardefs(t, vars) Cast$$make_vardefs(t, vars)
#define make_lambda Cast$$make_lambda
#define make_lambda_assign Cast$$make_lambda_assign
#define make_break Cast$$make_break
#define make_loop Cast$$make_loop
#define make_namedexpr Cast$$make_namedexpr
#define make_sini_expr Cast$$make_sini_expr
#define make_named_type Cast$$make_named_type
#define make_try_record Cast$$make_try_record
#define make_float_const Cast$$make_float_const
#define make_int_const Cast$$make_int_const
#define make_named_pattern Cast$$make_named_pattern
#define make_section_record Cast$$make_section_record

#define U(fld, val) \
	gont_make_union(GontUF_Ast__ ## fld, (val))

#define Some(x) \
	gont_make_union(GontUF_Std__Some, (x))

#define P(a, b) \
	gont_make_tuple(2, (a), (b))

#define TRIPLE(a, b, c) \
	gont_make_tuple(3, (a), (b), (c))

#define CONS(a, b) \
	gont_make_union(GontUF_List__Cons, P((a), (b)))

#define EXPR(fld, val) \
	make_expr(U(fld, (val)), &yyloc)

#define BIN(op, e1, e2) \
	EXPR(SimpleBinOp, TRIPLE(U(op, NULL), (e1), (e2)))

#define UNARY(op, e) \
	EXPR(SimpleUnOp, P(U(op, none), e))

#define LOCATED(x) \
	make_located(x, &yyloc)

#define STMT(fld, val) \
	LOCATED(U(fld, (val)))

#define PAIR(a, b) \
	STMT(Pair, P((a), (b)))

#define SKIP() \
	STMT(Skip, NULL)

#define LOOP(lab, body, inc) \
	LOCATED(make_loop(lab, body, inc))
#ifndef YYSTYPE
# define YYSTYPE int
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;

  int last_line;
  int last_column;
} yyltype;

# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		397
#define	YYFLAG		-32768
#define	YYNTBASE	85

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 317 ? yytranslate[x] : 165)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,     2,     2,     2,    69,     2,     2,
      79,    80,    68,    65,    76,    66,    74,    70,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    83,    75,
      63,    62,    64,     2,    67,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    81,     2,    82,     2,    84,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,     2,    78,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    71,    73
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     6,     8,    10,    12,    14,    16,
      18,    20,    22,    24,    26,    29,    32,    35,    36,    39,
      43,    47,    51,    55,    58,    60,    62,    66,    69,    71,
      75,    76,    79,    83,    84,    87,    91,    93,    96,   103,
     110,   117,   122,   126,   128,   130,   132,   134,   136,   142,
     150,   154,   156,   160,   161,   163,   165,   167,   169,   174,
     181,   190,   195,   199,   201,   203,   205,   208,   210,   214,
     215,   217,   223,   226,   231,   233,   237,   238,   240,   242,
     246,   250,   254,   256,   260,   263,   266,   269,   272,   274,
     278,   282,   286,   290,   294,   298,   302,   306,   310,   314,
     318,   321,   325,   330,   333,   335,   338,   342,   346,   350,
     354,   358,   362,   366,   370,   374,   378,   382,   386,   390,
     393,   395,   397,   399,   401,   403,   405,   407,   409,   411,
     413,   417,   419,   421,   425,   429,   431,   435,   441,   446,
     453,   457,   458,   461,   464,   466,   468,   470,   472,   474,
     476,   478,   480,   482,   488,   496,   504,   506,   510,   512,
     516,   519,   521,   523,   525,   526,   528,   529,   531,   533,
     534,   535,   538,   539,   541,   548,   557,   568,   570,   572,
     575,   577,   579,   582,   585,   588,   590,   594,   599,   602,
     603,   607,   609,   613,   616,   617,   622,   623,   628,   633,
     639,   643,   645,   646,   648,   652,   654,   656,   658,   660,
     663
};
static const short yyrhs[] =
{
      -1,    86,    85,     0,    87,     0,    93,     0,    90,     0,
      95,     0,   105,     0,    91,     0,   117,     0,    89,     0,
      88,     0,    94,     0,    75,     0,    35,     5,     0,    99,
      75,     0,    39,    99,     0,     0,    27,     6,     0,   116,
      92,   150,     0,    44,     5,   150,     0,    16,   116,    75,
       0,    16,    99,    75,     0,   116,   150,     0,     5,     0,
      97,     0,     5,    45,     5,     0,   112,    97,     0,     7,
       0,     7,    76,   100,     0,     0,    63,    64,     0,    63,
     100,    64,     0,     0,   102,    75,     0,   112,    98,   102,
       0,   103,     0,   103,   104,     0,    28,   101,     5,    77,
     104,    78,     0,    29,   101,     5,    77,   104,    78,     0,
      30,   101,     5,    77,   104,    78,     0,    32,   112,   101,
       5,     0,    31,   101,     5,     0,    11,     0,     9,     0,
      13,     0,    14,     0,    17,     0,    68,   112,    79,   115,
      80,     0,    68,    79,   112,    79,   115,    80,    80,     0,
     112,    76,   109,     0,   112,     0,   112,    76,   109,     0,
       0,   109,     0,   106,     0,   107,     0,     7,     0,    63,
     110,    64,    98,     0,    51,   109,    64,    98,    64,    98,
       0,    51,   109,    64,    98,    76,   109,    64,    98,     0,
      68,    81,   108,    82,     0,    79,   111,    80,     0,    98,
       0,   111,     0,   112,     0,   112,     5,     0,   113,     0,
     113,    76,   114,     0,     0,   114,     0,   112,    97,    79,
     115,    80,     0,   116,    75,     0,   116,    62,     6,    75,
       0,   126,     0,   126,    76,   118,     0,     0,   118,     0,
      98,     0,   126,    76,   126,     0,   126,    76,   121,     0,
      81,   121,    82,     0,   131,     0,   126,    62,   126,     0,
      54,   126,     0,    53,   126,     0,   126,    54,     0,   126,
      53,     0,   127,     0,   124,    65,   124,     0,   124,    66,
     124,     0,   124,    68,   124,     0,   124,    70,   124,     0,
     124,    69,   124,     0,   124,    63,   124,     0,   124,    64,
     124,     0,   124,    47,   124,     0,   124,    48,   124,     0,
     124,    49,   124,     0,   124,    50,   124,     0,    66,   124,
       0,    98,    81,    82,     0,    98,    81,   126,    82,     0,
      98,   122,     0,   127,     0,    72,   126,     0,   126,    65,
     126,     0,   126,    66,   126,     0,   126,    68,   126,     0,
     126,    70,   126,     0,   126,    69,   126,     0,   126,    63,
     126,     0,   126,    64,   126,     0,   126,    47,   126,     0,
     126,    48,   126,     0,   126,    49,   126,     0,   126,    50,
     126,     0,   126,    60,   126,     0,   126,    61,   126,     0,
      66,   126,     0,   122,     0,   123,     0,   130,     0,   125,
       0,     3,     0,     4,     0,     6,     0,    33,     0,    34,
       0,   120,     0,    79,   126,    80,     0,   132,     0,    36,
       0,   127,    74,    97,     0,    98,    62,   126,     0,   128,
       0,   128,    76,   129,     0,    79,    77,   129,    78,    80,
       0,   127,    79,   119,    80,     0,    18,   112,    79,   115,
      80,   150,     0,    77,   134,    78,     0,     0,   137,   134,
       0,   149,    75,     0,   133,     0,    96,     0,   148,     0,
     158,     0,   157,     0,   138,     0,   135,     0,   136,     0,
     139,     0,    19,    79,   126,    80,   136,     0,    19,    79,
     126,    80,   139,    20,   137,     0,    19,    79,   126,    80,
     135,    20,   137,     0,    97,     0,    97,    62,   126,     0,
     140,     0,   140,    76,   141,     0,   112,   141,     0,   123,
       0,   142,     0,    12,     0,     0,   126,     0,     0,   123,
       0,    12,     0,     0,     0,     5,    83,     0,     0,    97,
       0,   146,    21,    79,   126,    80,   137,     0,   146,    22,
     133,    21,    79,   126,    80,    75,     0,   146,    23,    79,
     143,    75,   144,    75,   145,    80,   137,     0,   123,     0,
      10,     0,    10,   126,     0,    12,     0,   142,     0,    37,
     126,     0,    40,   147,     0,    41,   147,     0,   133,     0,
      79,   126,    80,     0,    24,   164,    83,   134,     0,   151,
     152,     0,     0,   164,    62,   126,     0,   153,     0,   153,
      76,   154,     0,    42,   137,     0,     0,    43,    77,   152,
      78,     0,     0,    38,   133,   156,   155,     0,    26,   154,
      15,   137,     0,    25,   126,    77,   152,    78,     0,   164,
      76,   159,     0,   164,     0,     0,   159,     0,    81,   160,
      82,     0,   161,     0,    84,     0,   124,     0,   161,     0,
      98,   162,     0,   163,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   154,   156,   159,   163,   165,   166,   167,   168,   169,
     170,   171,   172,   179,   183,   187,   191,   195,   197,   200,
     206,   213,   215,   218,   226,   230,   232,   235,   242,   244,
     247,   249,   250,   253,   255,   258,   262,   264,   267,   270,
     272,   274,   276,   280,   282,   283,   284,   285,   288,   291,
     295,   299,   301,   304,   306,   309,   311,   312,   313,   315,
     317,   319,   322,   324,   325,   331,   333,   336,   338,   341,
     343,   346,   351,   353,   359,   361,   364,   366,   369,   373,
     375,   378,   383,   385,   386,   387,   388,   389,   392,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   408,   412,   414,   418,   422,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   444,   447,   449,   450,   451,   452,
     453,   454,   455,   456,   460,   465,   467,   470,   475,   480,
     488,   492,   494,   497,   499,   500,   501,   502,   503,   506,
     506,   507,   507,   509,   514,   517,   521,   523,   530,   532,
     535,   539,   541,   542,   543,   546,   548,   551,   553,   554,
     557,   559,   562,   564,   567,   572,   576,   587,   589,   590,
     591,   592,   593,   594,   596,   600,   602,   608,   612,   614,
     617,   621,   623,   626,   628,   631,   633,   636,   641,   644,
     652,   654,   657,   659,   662,   666,   670,   672,   673,   674,
     678
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "FLOAT", "ID", "STRING", "TYVAR", 
  "CHAR", "KW_INT", "KW_RETURN", "KW_VOID", "KW_SKIP", "KW_BOOL", 
  "KW_FLOAT", "KW_IN", "KW_EXTERN_C", "KW_STRING", "KW_FUN", "KW_IF", 
  "KW_ELSE", "KW_WHILE", "KW_DO", "KW_FOR", "KW_CASE", "KW_SWITCH", 
  "KW_LET", "KW_EXPORT_AS", "KW_STRUCT", "KW_OPT_STRUCT", "KW_UNION", 
  "KW_TYPE", "KW_TYPEDEF", "KW_TRUE", "KW_FALSE", "KW_OPEN", "KW_NULL", 
  "KW_RAISE", "KW_TRY", "KW_EXCEPTION", "KW_BREAK", "KW_CONTINUE", 
  "KW_FINALLY", "KW_WITH", "KW_SECTION", "DOUBLECOLON", "ARROW", "GE", 
  "LE", "EQ", "NE", "LTLT", "GTGT", "PLUS_PLUS", "MINUS_MINUS", 
  "SLASH_EQUAL", "PLUS_EQUAL", "MINUS_EQUAL", "PERCENT_EQUAL", 
  "STAR_EQUAL", "AND_AND", "OR_OR", "'='", "'<'", "'>'", "'+'", "'-'", 
  "'@'", "'*'", "'%'", "'/'", "UMINUS", "'!'", "APPLICATION", "'.'", 
  "';'", "','", "'{'", "'}'", "'('", "')'", "'['", "']'", "':'", "'_'", 
  "module", "decl", "nl_decl", "dummy_decl", "top_open", "global_var", 
  "exn_decl", "maybe_export_as", "func", "section", "extern_c", 
  "func_def", "id", "qid", "vardef", "type_var_list_content", 
  "type_var_list", "maybe_semicolons", "record_type_fld", 
  "record_type_flds", "type_decl", "simple_type", "function_type", 
  "tuple_ty", "ne_ty_list", "ty_list", "xtype_exp", "type_exp", 
  "func_arg", "ne_func_args", "func_args", "func_header", "func_proto", 
  "ne_expr_list", "expr_list", "variable", "tuple_content", "tuple", 
  "stmt_expr", "pattern_expr", "union_expr", "expr", "primary", 
  "struct_init", "struct_expr_content", "struct_expr", "call", "lambda", 
  "block", "stmts", "non_if_stmt", "no_else", "stmt", "if_stmt", 
  "if_else_stmt", "single_var_def", "var_def_list", "var_def", "for_exp1", 
  "for_exp2", "for_exp3", "maybe_label", "maybe_id", "loop_stmt", 
  "normal_stmt", "fnc_body", "case_clause", "case_list", "pattern_eq", 
  "pattern_eq_list", "maybe_finally", "maybe_with", "try_stmt", 
  "pattern_matching_stmt", "ne_pattern_list", "pattern_list", 
  "raw_tuple_pattern", "tuple_pattern", "raw_pattern", "pattern", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    85,    85,    86,    87,    87,    87,    87,    87,    87,
      87,    87,    87,    88,    89,    90,    91,    92,    92,    93,
      94,    95,    95,    96,    97,    98,    98,    99,   100,   100,
     101,   101,   101,   102,   102,   103,   104,   104,   105,   105,
     105,   105,   105,   106,   106,   106,   106,   106,   107,   107,
     108,   109,   109,   110,   110,   111,   111,   111,   111,   111,
     111,   111,   112,   112,   112,   113,   113,   114,   114,   115,
     115,   116,   117,   117,   118,   118,   119,   119,   120,   121,
     121,   122,   123,   123,   123,   123,   123,   123,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   125,   125,   125,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   128,   129,   129,   130,   131,   132,
     133,   134,   134,   135,   135,   135,   135,   135,   135,   136,
     136,   137,   137,   138,   139,   139,   140,   140,   141,   141,
     142,   143,   143,   143,   143,   144,   144,   145,   145,   145,
     146,   146,   147,   147,   148,   148,   148,   149,   149,   149,
     149,   149,   149,   149,   149,   150,   150,   151,   152,   152,
     153,   154,   154,   155,   155,   156,   156,   157,   158,   158,
     159,   159,   160,   160,   161,   162,   163,   163,   163,   163,
     164
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     0,     2,     3,
       3,     3,     3,     2,     1,     1,     3,     2,     1,     3,
       0,     2,     3,     0,     2,     3,     1,     2,     6,     6,
       6,     4,     3,     1,     1,     1,     1,     1,     5,     7,
       3,     1,     3,     0,     1,     1,     1,     1,     4,     6,
       8,     4,     3,     1,     1,     1,     2,     1,     3,     0,
       1,     5,     2,     4,     1,     3,     0,     1,     1,     3,
       3,     3,     1,     3,     2,     2,     2,     2,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     4,     2,     1,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     3,     3,     1,     3,     5,     4,     6,
       3,     0,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     7,     7,     1,     3,     1,     3,
       2,     1,     1,     1,     0,     1,     0,     1,     1,     0,
       0,     2,     0,     1,     6,     8,    10,     1,     1,     2,
       1,     1,     2,     2,     2,     1,     3,     4,     2,     0,
       3,     1,     3,     2,     0,     4,     0,     4,     4,     5,
       3,     1,     0,     1,     3,     1,     1,     1,     1,     2,
       1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,    24,    57,    44,    43,    45,    46,     0,    47,    30,
      30,    30,    30,     0,     0,     0,     0,     0,    53,     0,
      13,     0,     1,     3,    11,    10,     5,     8,     4,    12,
       6,    25,    63,     0,     7,    55,    56,    64,     0,    17,
       9,     0,     0,     0,     0,     0,     0,     0,     0,    30,
      14,    16,     0,     0,     0,    51,    54,     0,     0,     0,
       0,     0,     2,    15,    24,    27,     0,     0,    72,     0,
      26,    22,    21,    28,    31,     0,     0,     0,     0,    42,
       0,    27,   170,     0,   185,    20,     0,     0,     0,    64,
       0,     0,     0,    69,    62,    69,    18,     0,    19,     0,
      32,     0,     0,     0,    41,   124,   125,    24,   126,   178,
     180,     0,     0,     0,     0,   127,   128,   132,     0,     0,
     172,   172,     0,     0,     0,     0,     0,     0,   145,    78,
       0,     0,   129,   120,   121,   123,     0,   104,   122,    82,
     131,   144,     0,   150,   151,   170,   149,   152,   181,     0,
     146,     0,   148,   147,     0,    78,   121,     0,     0,    52,
      58,    69,    61,     0,    65,    67,    70,     0,     0,    73,
      29,    36,     0,     0,     0,     0,   171,   179,     0,     0,
       0,     0,     0,   202,   206,    78,   207,    88,   191,     0,
     208,   210,     0,   182,   196,   173,   183,   184,    85,    84,
     119,   105,     0,     0,     0,     0,     0,   103,   156,   158,
     160,    23,     0,     0,     0,     0,    87,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    76,
     140,   142,     0,     0,     0,   143,   186,     0,     0,     0,
      50,    66,     0,    48,    71,    37,    38,    33,    39,    40,
      69,     0,   189,    78,   100,   203,     0,   201,   205,   209,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   170,     0,     0,   194,     0,   135,     0,   130,
      81,     0,   101,     0,     0,     0,   113,   114,   115,   116,
     117,   118,    83,   111,   112,   106,   107,   108,   110,   109,
     133,    77,     0,    74,     0,     0,   164,    59,     0,     0,
      68,    35,     0,   170,     0,   189,     0,   204,     0,    96,
      97,    98,    99,    94,    95,    89,    90,    91,    93,    92,
     192,   198,   190,   189,   170,   197,     0,     0,     0,    80,
      79,   102,   157,   156,   159,   138,     0,     0,     0,   163,
       0,   121,   162,     0,     0,    49,    34,     0,   150,   153,
       0,     0,   188,   199,   200,     0,   193,   134,   136,   137,
      75,   170,     0,   166,    60,   139,   170,   170,   170,   195,
     174,     0,   165,     0,   155,   154,   187,     0,   169,   175,
     168,   121,     0,   170,   176,     0,     0,     0
};

static const short yydefgoto[] =
{
      62,    22,    23,    24,    25,    26,    27,    69,    28,    29,
      30,   128,    31,   155,    33,    75,    45,   311,   171,   172,
      34,    35,    36,    91,    54,    57,    37,   130,   165,   166,
     167,   131,    40,   301,   302,   132,   204,   133,   156,   186,
     135,   136,   137,   277,   278,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   209,   210,   148,   353,   383,
     392,   149,   196,   150,   151,    85,   315,   316,   188,   189,
     335,   275,   152,   153,   255,   256,   190,   259,   191,   192
};

static const short yypact[] =
{
     890,   -31,-32768,-32768,-32768,-32768,-32768,   919,-32768,   -16,
     -16,   -16,   -16,   919,    39,   919,    56,   919,   919,   143,
  -32768,   121,   890,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,   -13,-32768,-32768,-32768,-32768,    63,     5,
  -32768,    64,    -3,    -2,    -1,    71,    79,    89,   102,   -16,
  -32768,-32768,    63,     2,    46,    37,-32768,    48,   919,   919,
      40,    42,-32768,-32768,-32768,    44,   110,   118,-32768,     2,
  -32768,-32768,-32768,    50,-32768,    65,    66,    67,    70,-32768,
     122,-32768,   599,   813,-32768,-32768,   131,   919,   131,    42,
      72,    73,    82,   919,-32768,   919,-32768,    87,-32768,   157,
  -32768,   919,   919,   919,-32768,-32768,-32768,   -35,-32768,   813,
  -32768,   919,    86,   813,   164,-32768,-32768,-32768,   813,    99,
      63,    63,   813,   813,   813,   813,   437,   813,-32768,     4,
      63,     2,-32768,-32768,    91,-32768,  1124,   -38,-32768,-32768,
  -32768,-32768,   108,-32768,-32768,   520,-32768,-32768,-32768,    77,
  -32768,   105,-32768,-32768,   779,   106,-32768,   931,   -22,-32768,
  -32768,   919,-32768,   919,   183,   114,-32768,   112,   113,-32768,
  -32768,   919,   117,   131,   125,   126,-32768,  1124,   128,   813,
    1051,   720,   813,   164,-32768,   115,   579,   134,   129,   195,
  -32768,-32768,   150,  1124,   170,-32768,-32768,-32768,   -19,   -19,
     -19,   -19,   131,   955,   132,  1076,   429,-32768,   -29,   139,
  -32768,-32768,   813,   813,   813,   813,-32768,-32768,   813,   813,
     813,   813,   813,   813,   813,   813,   813,   813,    63,   813,
  -32768,-32768,   138,    99,   140,-32768,-32768,   131,   919,   141,
  -32768,-32768,   919,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     919,   979,   194,-32768,-32768,-32768,   144,   147,-32768,-32768,
     720,   720,   720,   720,   720,   720,   720,   720,   720,   720,
     720,   164,   678,   813,   152,   178,   165,   155,   156,-32768,
  -32768,   813,-32768,   299,   813,    63,   906,   906,   497,   497,
     898,   898,  1124,   906,   906,    21,    21,   -19,   -19,   -19,
  -32768,-32768,   153,  1100,   813,   215,   757,-32768,   175,   161,
  -32768,   169,   166,   678,   164,   194,   171,-32768,   164,   812,
     812,   109,   109,   812,   812,    36,    36,-32768,-32768,-32768,
  -32768,-32768,  1124,   194,   678,-32768,   813,   131,   167,-32768,
    1076,-32768,  1124,   189,-32768,-32768,   813,  1003,   173,-32768,
      63,   179,-32768,   180,   131,-32768,-32768,     2,   236,-32768,
     237,   192,-32768,-32768,-32768,   199,-32768,  1124,-32768,-32768,
  -32768,   678,   813,   813,-32768,-32768,   678,   678,   520,-32768,
  -32768,  1027,  1124,   203,-32768,-32768,-32768,   204,   836,-32768,
  -32768,   201,   202,   678,-32768,   258,   283,-32768
};

static const short yypgoto[] =
{
     284,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   -12,     0,    24,   187,    17,-32768,-32768,   -79,
  -32768,-32768,-32768,-32768,   -10,-32768,    -9,    38,-32768,    45,
     -91,    30,-32768,   -54,-32768,-32768,    12,  -109,   -81,    59,
  -32768,   176,   160,-32768,   -33,-32768,-32768,-32768,   -48,  -143,
      -8,    -5,  -256,-32768,     3,-32768,    25,     9,-32768,-32768,
  -32768,-32768,   190,-32768,-32768,   -66,-32768,  -290,-32768,    60,
  -32768,-32768,-32768,-32768,    14,-32768,   148,-32768,-32768,  -172
};


#define	YYLAST		1194


static const short yytable[] =
{
      32,   134,   231,    98,   168,    84,    73,    32,    56,   -63,
      41,   257,    61,    32,    41,    32,   331,    32,    32,    32,
     207,    84,    32,   174,   175,   362,    65,    46,    47,    48,
      39,    42,    66,   284,   216,   217,   228,    43,    38,    51,
      81,   229,   237,   365,    50,    38,   207,    44,   176,    89,
      95,    49,    39,    52,   238,    55,    55,    60,    32,    32,
      38,    53,    63,    74,   134,   211,    80,    67,    64,    70,
     239,   194,    71,    72,   216,   217,    76,   159,   366,    82,
      68,    83,   129,    84,    77,   206,   158,    32,   160,   225,
     226,   227,   245,    32,    78,    32,    90,    92,   232,   233,
     234,    32,    32,    32,   268,   269,   270,    79,   195,   195,
      86,    32,    88,    87,   185,   380,    96,    61,   208,    93,
     384,   385,    94,    95,    97,    55,    99,   104,     2,   100,
       3,   164,     4,   164,     5,     6,     1,   394,     8,   173,
     173,   173,   361,   101,   102,   129,   257,   103,     1,   178,
       2,   161,     3,   240,     4,   162,     5,     6,   163,   312,
       8,    32,   169,    32,    73,   179,  -177,   105,   106,     1,
     108,    32,    17,   247,   266,   267,    82,   268,   269,   270,
     235,   253,   111,   185,    18,   305,   230,   206,   241,    19,
     242,   134,   243,   244,    17,   246,   183,   115,   116,   164,
     117,    55,   276,   248,   249,   271,    18,   250,   228,   173,
     272,    19,   273,   274,   280,   285,   300,   304,   314,   306,
     334,   309,    58,   318,    59,   351,   317,   336,   308,   333,
     181,   337,   134,   345,   338,   386,   348,   307,    32,   354,
     254,   355,    32,   182,   356,   183,   357,   369,   184,   363,
      32,   284,   372,   134,  -161,   373,   376,   377,   396,   157,
     253,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     253,   185,   129,   343,   187,   378,    55,   379,   388,   389,
     164,  -167,   393,   397,   395,   177,   170,   310,   164,   180,
     134,   375,   370,   339,   193,   134,   134,   134,   198,   199,
     200,   201,   203,   205,   368,   358,   129,   391,   359,    84,
     344,   197,   134,   129,   185,   352,   360,     0,   185,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     203,   330,   364,   258,   129,     0,     0,   276,   343,     0,
       0,   187,     0,   187,   350,     0,   212,   213,   214,   215,
       0,     0,   216,   217,   374,   251,     0,     0,   203,   218,
     219,   220,   221,   222,   223,   224,     0,   225,   226,   227,
       0,   129,     0,     0,     0,   281,   129,   129,   129,     0,
       0,   341,   283,     0,     0,     0,     0,     0,   286,   287,
     288,   289,     0,   129,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,     0,   303,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   105,   106,     1,   108,     0,     0,     0,     0,
     105,   106,     1,   108,     2,     0,     3,   111,     4,   332,
       5,     6,     0,     0,     8,   111,     0,   340,     0,     0,
     342,     0,   115,   116,     0,   117,     0,     0,     0,     0,
     115,   116,     0,   117,   187,     0,     0,     0,   187,     0,
     347,     0,   122,   123,     0,     0,     0,     0,    17,     0,
     122,   123,     0,     0,     0,   124,     0,     0,     0,     0,
      18,   125,     0,   124,     0,    19,     0,     0,   154,   125,
     127,   282,   367,     0,   202,     0,   154,     0,   127,     0,
       0,     0,   303,   105,   106,   107,   108,     2,     0,     3,
     109,     4,   110,     5,     6,     0,     0,     8,   111,   112,
       0,     0,     0,     0,  -141,   113,   114,     0,   381,   382,
     216,   217,     0,   115,   116,     0,   117,   118,   119,     0,
     120,   121,   223,   224,     0,   225,   226,   227,     0,     0,
       0,    17,     0,   122,   123,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,   124,     0,    19,     0,
       0,     0,   125,     0,     0,     0,     0,    82,  -141,   126,
       0,   127,   105,   106,   107,   108,     2,     0,     3,   109,
       4,   110,     5,     6,     0,     0,     8,   111,   112,     0,
       0,     0,     0,     0,   113,   114,   260,   261,   262,   263,
       0,     0,   115,   116,     0,   117,   118,   119,     0,   120,
     121,     0,   264,   265,   266,   267,     0,   268,   269,   270,
      17,     0,   122,   123,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,     0,   124,     0,    19,     0,     0,
       0,   125,     0,     0,     0,     0,    82,  -141,   126,     0,
     127,   105,   106,   107,   108,     2,     0,     3,   109,     4,
     110,     5,     6,     0,     0,     8,   111,   112,     0,     0,
       0,     0,     0,   113,   114,     0,     0,     0,     0,     0,
       0,   115,   116,     0,   117,   118,   119,     0,   120,   121,
       0,     0,     0,   105,   106,     1,   108,     0,     0,    17,
       0,   122,   123,     0,     0,     0,     0,     0,   111,     0,
       0,    18,     0,     0,   124,     0,    19,     0,     0,     0,
     125,     0,     0,   115,   116,    82,   117,   126,     0,   127,
     105,   106,     1,   108,     2,     0,     3,     0,     4,   349,
       5,     6,     0,     0,     8,   111,     0,     0,     0,     0,
       0,     0,   105,   106,     1,   108,   181,     0,     0,     0,
     115,   116,     0,   117,     0,     0,     0,   111,     0,   182,
       0,     0,     0,     0,     0,     0,     0,     0,    17,     0,
     122,   123,   115,   116,     0,   117,   105,   106,     1,   108,
      18,     0,     0,   124,     0,    19,     0,     0,     0,   125,
       0,   111,   122,   123,     0,     0,   126,     0,   127,   105,
     106,     1,   108,     0,     0,   124,   115,   116,   390,   117,
       0,   125,     0,     0,   111,     0,   202,     0,   154,     0,
     127,   262,   263,     0,     0,     0,   122,   123,     0,   115,
     116,     0,   117,     0,     0,     0,     0,   266,   267,   124,
     268,   269,   270,     0,     0,   125,     0,     0,     0,   122,
     123,     0,   154,     0,   127,     1,     0,     2,     0,     3,
       0,     4,   124,     5,     6,     0,     7,     8,   125,     0,
       0,     0,     0,     0,     0,   154,     0,   127,     9,    10,
      11,    12,    13,     0,     1,    14,     2,     0,     3,    15,
       4,     0,     5,     6,    16,     0,     8,     0,     0,     0,
       0,    17,     0,     0,     0,   212,   213,   214,   215,     0,
       0,   216,   217,    18,     0,   214,   215,     0,    19,   216,
     217,   221,   222,   223,   224,    20,   225,   226,   227,    21,
      17,   223,   224,     0,   225,   226,   227,     0,   212,   213,
     214,   215,    18,     0,   216,   217,     0,    19,     0,     0,
       0,   218,   219,   220,   221,   222,   223,   224,    21,   225,
     226,   227,   212,   213,   214,   215,     0,     0,   216,   217,
       0,   236,     0,     0,     0,   218,   219,   220,   221,   222,
     223,   224,     0,   225,   226,   227,   212,   213,   214,   215,
       0,     0,   216,   217,     0,   279,     0,     0,     0,   218,
     219,   220,   221,   222,   223,   224,     0,   225,   226,   227,
     212,   213,   214,   215,     0,     0,   216,   217,     0,   313,
       0,     0,     0,   218,   219,   220,   221,   222,   223,   224,
       0,   225,   226,   227,   212,   213,   214,   215,     0,     0,
     216,   217,     0,   371,     0,     0,     0,   218,   219,   220,
     221,   222,   223,   224,     0,   225,   226,   227,   212,   213,
     214,   215,     0,     0,   216,   217,     0,   387,     0,     0,
       0,   218,   219,   220,   221,   222,   223,   224,     0,   225,
     226,   227,     0,   212,   213,   214,   215,     0,   252,   216,
     217,     0,     0,     0,     0,     0,   218,   219,   220,   221,
     222,   223,   224,     0,   225,   226,   227,   212,   213,   214,
     215,     0,   281,   216,   217,     0,     0,     0,     0,     0,
     218,   219,   220,   221,   222,   223,   224,     0,   225,   226,
     227,   212,   213,   214,   215,     0,   346,   216,   217,     0,
       0,     0,     0,     0,   218,   219,   220,   221,   222,   223,
     224,     0,   225,   226,   227
};

static const short yycheck[] =
{
       0,    82,   145,    69,    95,    53,     7,     7,    18,     5,
      45,   183,    21,    13,    45,    15,   272,    17,    18,    19,
     129,    69,    22,   102,   103,   315,    38,    10,    11,    12,
       0,     7,    27,    62,    53,    54,    74,     7,     0,    15,
      52,    79,    64,   333,     5,     7,   155,    63,    83,    58,
      79,    13,    22,    15,    76,    17,    18,    19,    58,    59,
      22,     5,    75,    64,   145,   131,    49,    62,     5,     5,
     161,   119,    75,    75,    53,    54,     5,    87,   334,    77,
      75,    79,    82,   131,     5,    81,    86,    87,    88,    68,
      69,    70,   171,    93,     5,    95,    58,    59,    21,    22,
      23,   101,   102,   103,    68,    69,    70,     5,   120,   121,
      64,   111,    64,    76,   114,   371,     6,   126,   130,    79,
     376,   377,    80,    79,     6,    87,    76,     5,     7,    64,
       9,    93,    11,    95,    13,    14,     5,   393,    17,   101,
     102,   103,   314,    77,    77,   145,   318,    77,     5,   111,
       7,    79,     9,   163,    11,    82,    13,    14,    76,   250,
      17,   161,    75,   163,     7,    79,    75,     3,     4,     5,
       6,   171,    51,   173,    65,    66,    77,    68,    69,    70,
      75,   181,    18,   183,    63,   233,    78,    81,     5,    68,
      76,   272,    80,    80,    51,    78,    81,    33,    34,   161,
      36,   163,   202,    78,    78,    76,    63,    79,    74,   171,
      15,    68,    62,    43,    82,    76,   228,    79,    24,    79,
      42,    80,    79,    76,    81,   306,    82,    62,   238,    77,
      66,    76,   313,    80,    78,   378,    21,   237,   238,    64,
     181,    80,   242,    79,    75,    81,    80,    80,    84,    78,
     250,    62,    79,   334,    75,    75,    20,    20,     0,    83,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   285,   114,    83,   238,    78,    75,    75,
     242,    80,    80,     0,     0,   109,    99,   242,   250,   113,
     371,   357,   346,   281,   118,   376,   377,   378,   122,   123,
     124,   125,   126,   127,   337,   313,   306,   388,   313,   357,
     285,   121,   393,   313,   314,   306,   313,    -1,   318,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     154,   271,   318,   185,   334,    -1,    -1,   337,   350,    -1,
      -1,   181,    -1,   183,   306,    -1,    47,    48,    49,    50,
      -1,    -1,    53,    54,   354,   179,    -1,    -1,   182,    60,
      61,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      -1,   371,    -1,    -1,    -1,    76,   376,   377,   378,    -1,
      -1,    82,   206,    -1,    -1,    -1,    -1,    -1,   212,   213,
     214,   215,    -1,   393,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,     3,     4,     5,     6,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,    -1,     9,    18,    11,   273,
      13,    14,    -1,    -1,    17,    18,    -1,   281,    -1,    -1,
     284,    -1,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,   314,    -1,    -1,    -1,   318,    -1,
     304,    -1,    53,    54,    -1,    -1,    -1,    -1,    51,    -1,
      53,    54,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      63,    72,    -1,    66,    -1,    68,    -1,    -1,    79,    72,
      81,    82,   336,    -1,    77,    -1,    79,    -1,    81,    -1,
      -1,    -1,   346,     3,     4,     5,     6,     7,    -1,     9,
      10,    11,    12,    13,    14,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    24,    25,    26,    -1,   372,   373,
      53,    54,    -1,    33,    34,    -1,    36,    37,    38,    -1,
      40,    41,    65,    66,    -1,    68,    69,    70,    -1,    -1,
      -1,    51,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    -1,    66,    -1,    68,    -1,
      -1,    -1,    72,    -1,    -1,    -1,    -1,    77,    78,    79,
      -1,    81,     3,     4,     5,     6,     7,    -1,     9,    10,
      11,    12,    13,    14,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    25,    26,    47,    48,    49,    50,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    -1,    40,
      41,    -1,    63,    64,    65,    66,    -1,    68,    69,    70,
      51,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    63,    -1,    -1,    66,    -1,    68,    -1,    -1,
      -1,    72,    -1,    -1,    -1,    -1,    77,    78,    79,    -1,
      81,     3,     4,     5,     6,     7,    -1,     9,    10,    11,
      12,    13,    14,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    25,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    -1,    40,    41,
      -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,    51,
      -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    18,    -1,
      -1,    63,    -1,    -1,    66,    -1,    68,    -1,    -1,    -1,
      72,    -1,    -1,    33,    34,    77,    36,    79,    -1,    81,
       3,     4,     5,     6,     7,    -1,     9,    -1,    11,    12,
      13,    14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,    66,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    -1,    -1,    18,    -1,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      53,    54,    33,    34,    -1,    36,     3,     4,     5,     6,
      63,    -1,    -1,    66,    -1,    68,    -1,    -1,    -1,    72,
      -1,    18,    53,    54,    -1,    -1,    79,    -1,    81,     3,
       4,     5,     6,    -1,    -1,    66,    33,    34,    12,    36,
      -1,    72,    -1,    -1,    18,    -1,    77,    -1,    79,    -1,
      81,    49,    50,    -1,    -1,    -1,    53,    54,    -1,    33,
      34,    -1,    36,    -1,    -1,    -1,    -1,    65,    66,    66,
      68,    69,    70,    -1,    -1,    72,    -1,    -1,    -1,    53,
      54,    -1,    79,    -1,    81,     5,    -1,     7,    -1,     9,
      -1,    11,    66,    13,    14,    -1,    16,    17,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    -1,    81,    28,    29,
      30,    31,    32,    -1,     5,    35,     7,    -1,     9,    39,
      11,    -1,    13,    14,    44,    -1,    17,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    47,    48,    49,    50,    -1,
      -1,    53,    54,    63,    -1,    49,    50,    -1,    68,    53,
      54,    63,    64,    65,    66,    75,    68,    69,    70,    79,
      51,    65,    66,    -1,    68,    69,    70,    -1,    47,    48,
      49,    50,    63,    -1,    53,    54,    -1,    68,    -1,    -1,
      -1,    60,    61,    62,    63,    64,    65,    66,    79,    68,
      69,    70,    47,    48,    49,    50,    -1,    -1,    53,    54,
      -1,    80,    -1,    -1,    -1,    60,    61,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    47,    48,    49,    50,
      -1,    -1,    53,    54,    -1,    80,    -1,    -1,    -1,    60,
      61,    62,    63,    64,    65,    66,    -1,    68,    69,    70,
      47,    48,    49,    50,    -1,    -1,    53,    54,    -1,    80,
      -1,    -1,    -1,    60,    61,    62,    63,    64,    65,    66,
      -1,    68,    69,    70,    47,    48,    49,    50,    -1,    -1,
      53,    54,    -1,    80,    -1,    -1,    -1,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    47,    48,
      49,    50,    -1,    -1,    53,    54,    -1,    80,    -1,    -1,
      -1,    60,    61,    62,    63,    64,    65,    66,    -1,    68,
      69,    70,    -1,    47,    48,    49,    50,    -1,    77,    53,
      54,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    47,    48,    49,
      50,    -1,    76,    53,    54,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    66,    -1,    68,    69,
      70,    47,    48,    49,    50,    -1,    76,    53,    54,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      66,    -1,    68,    69,    70
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/misc/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 155 "parser.y"
{ yyval = nil; decls = yyval; ;
    break;}
case 2:
#line 156 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); decls = yyval; ;
    break;}
case 3:
#line 160 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
case 13:
#line 180 "parser.y"
{ yyval = U(DummyDecl, NULL); ;
    break;}
case 14:
#line 184 "parser.y"
{ yyval = U(TopLevelOpen, yyvsp[0]); ;
    break;}
case 15:
#line 188 "parser.y"
{ yyval = U(GlobalDecl, yyvsp[-1]); ;
    break;}
case 16:
#line 192 "parser.y"
{ yyval = U(ExceptionDecl, yyvsp[0]); ;
    break;}
case 17:
#line 196 "parser.y"
{ yyval = empty_string; ;
    break;}
case 18:
#line 197 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 19:
#line 202 "parser.y"
{ yyval = make_fn_decl(yyvsp[-2], yyvsp[-1], yyvsp[0]); ;
    break;}
case 20:
#line 208 "parser.y"
{ yyval = U(SectionDecl, P(yyvsp[-1], make_section_record(yyvsp[0]))); ;
    break;}
case 21:
#line 214 "parser.y"
{ yyval = U(ExternC, yyvsp[-1]); ;
    break;}
case 22:
#line 215 "parser.y"
{ yyval = U(ExternC, yyvsp[-1]); ;
    break;}
case 23:
#line 220 "parser.y"
{ yyval = LOCATED(make_lambda_assign(yyvsp[-1], yyvsp[0])); ;
    break;}
case 24:
#line 227 "parser.y"
{ yyval = U(SimpleName, yyvsp[0]); ;
    break;}
case 26:
#line 232 "parser.y"
{ yyval = U(QualifiedName, P(yyvsp[-2], yyvsp[0])); ;
    break;}
case 27:
#line 236 "parser.y"
{ yyval = make_vardef(yyvsp[-1], yyvsp[0]); ;
    break;}
case 28:
#line 243 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 29:
#line 244 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]) ;
    break;}
case 30:
#line 248 "parser.y"
{ yyval = nil; ;
    break;}
case 31:
#line 249 "parser.y"
{ yyval = nil; ;
    break;}
case 32:
#line 250 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 33:
#line 254 "parser.y"
{ yyval = nil; ;
    break;}
case 34:
#line 255 "parser.y"
{ yyval = nil; ;
    break;}
case 35:
#line 259 "parser.y"
{ yyval = make_field(yyvsp[-2], yyvsp[-1]); ;
    break;}
case 36:
#line 263 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 37:
#line 264 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 38:
#line 269 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(Struct, yyvsp[-1])); ;
    break;}
case 39:
#line 271 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(OptStruct, yyvsp[-1])); ;
    break;}
case 40:
#line 273 "parser.y"
{ yyval = make_tydef(yyvsp[-3], yyvsp[-4], U(Union, yyvsp[-1])); ;
    break;}
case 41:
#line 275 "parser.y"
{ yyval = make_tydef(yyvsp[0], yyvsp[-1], yyvsp[-2]); ;
    break;}
case 42:
#line 277 "parser.y"
{ yyval = make_tydef(yyvsp[0], yyvsp[-1], U(AbstractType, NULL)); ;
    break;}
case 43:
#line 281 "parser.y"
{ yyval = U(Void, NULL); ;
    break;}
case 44:
#line 282 "parser.y"
{ yyval = U(Int, NULL); ;
    break;}
case 45:
#line 283 "parser.y"
{ yyval = U(Bool, NULL); ;
    break;}
case 46:
#line 284 "parser.y"
{ yyval = U(Float, NULL); ;
    break;}
case 47:
#line 285 "parser.y"
{ yyval = U(String, NULL); ;
    break;}
case 48:
#line 290 "parser.y"
{ yyval = bare_fn_type(yyvsp[-3], yyvsp[-1]); ;
    break;}
case 49:
#line 292 "parser.y"
{ yyval = bare_fn_type(yyvsp[-4], yyvsp[-2]); ;
    break;}
case 50:
#line 296 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 51:
#line 300 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 52:
#line 301 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 53:
#line 305 "parser.y"
{ yyval = nil; ;
    break;}
case 54:
#line 306 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 55:
#line 310 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 56:
#line 311 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 57:
#line 312 "parser.y"
{ yyval = make_tyvar(yyvsp[0]); ;
    break;}
case 58:
#line 313 "parser.y"
{ yyval = make_named_type(yyvsp[0], yyvsp[-2]); ;
    break;}
case 59:
#line 316 "parser.y"
{ yyval = make_named_type(yyvsp[0], CONS(make_named_type(yyvsp[-2], yyvsp[-4]), nil)); ;
    break;}
case 60:
#line 318 "parser.y"
{ yyval = make_named_type(yyvsp[0], CONS(make_named_type(yyvsp[-4], yyvsp[-6]), yyvsp[-2])); ;
    break;}
case 61:
#line 319 "parser.y"
{ yyval = U(Tuple, yyvsp[-1]); ;
    break;}
case 62:
#line 323 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 63:
#line 324 "parser.y"
{ yyval = make_named_type(yyvsp[0], nil); ;
    break;}
case 64:
#line 325 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 65:
#line 332 "parser.y"
{ yyval = P(yyvsp[0], none); ;
    break;}
case 66:
#line 333 "parser.y"
{ yyval = P(yyvsp[-1], Some(yyvsp[0])); ;
    break;}
case 67:
#line 337 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 68:
#line 338 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 69:
#line 342 "parser.y"
{ yyval = nil; ;
    break;}
case 70:
#line 343 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 71:
#line 348 "parser.y"
{ yyval = make_vardef(bare_fn_type(yyvsp[-4], yyvsp[-1]), yyvsp[-3]); ;
    break;}
case 72:
#line 352 "parser.y"
{ yyval = U(FuncProto, yyvsp[-1]); ;
    break;}
case 73:
#line 353 "parser.y"
{ yyval = U(XCFuncProto, P(yyvsp[-1], yyvsp[-3])); ;
    break;}
case 74:
#line 360 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 75:
#line 361 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 76:
#line 365 "parser.y"
{ yyval = nil; ;
    break;}
case 77:
#line 366 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 78:
#line 370 "parser.y"
{ yyval = EXPR(Ref, make_ref_record(yyvsp[0])); ;
    break;}
case 79:
#line 374 "parser.y"
{ yyval = CONS(yyvsp[-2], CONS(yyvsp[0], nil)); ;
    break;}
case 80:
#line 375 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 81:
#line 379 "parser.y"
{ yyval = EXPR(TupleExpr, yyvsp[-1]); ;
    break;}
case 82:
#line 384 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 83:
#line 385 "parser.y"
{ yyval = BIN(Assign, yyvsp[-2], yyvsp[0]); ;
    break;}
case 84:
#line 386 "parser.y"
{ yyval = UNARY(PreDec, yyvsp[0]); ;
    break;}
case 85:
#line 387 "parser.y"
{ yyval = UNARY(PreInc, yyvsp[0]); ;
    break;}
case 86:
#line 388 "parser.y"
{ yyval = UNARY(PostDec, yyvsp[-1]); ;
    break;}
case 87:
#line 389 "parser.y"
{ yyval = UNARY(PostInc, yyvsp[-1]); ;
    break;}
case 88:
#line 393 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 89:
#line 394 "parser.y"
{ yyval = BIN(Plus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 90:
#line 395 "parser.y"
{ yyval = BIN(Minus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 91:
#line 396 "parser.y"
{ yyval = BIN(Mult, yyvsp[-2], yyvsp[0]); ;
    break;}
case 92:
#line 397 "parser.y"
{ yyval = BIN(Div, yyvsp[-2], yyvsp[0]); ;
    break;}
case 93:
#line 398 "parser.y"
{ yyval = BIN(Mod, yyvsp[-2], yyvsp[0]); ;
    break;}
case 94:
#line 399 "parser.y"
{ yyval = BIN(Lt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 95:
#line 400 "parser.y"
{ yyval = BIN(Gt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 96:
#line 401 "parser.y"
{ yyval = BIN(Ge, yyvsp[-2], yyvsp[0]); ;
    break;}
case 97:
#line 402 "parser.y"
{ yyval = BIN(Le, yyvsp[-2], yyvsp[0]); ;
    break;}
case 98:
#line 403 "parser.y"
{ yyval = BIN(Eq, yyvsp[-2], yyvsp[0]); ;
    break;}
case 99:
#line 404 "parser.y"
{ yyval = BIN(Ne, yyvsp[-2], yyvsp[0]); ;
    break;}
case 100:
#line 405 "parser.y"
{ yyval = UNARY(Negate, yyvsp[0]); ;
    break;}
case 101:
#line 411 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-2], EXPR(VoidConst, NULL))); ;
    break;}
case 102:
#line 413 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 103:
#line 415 "parser.y"
{ yyval = EXPR(UnionExpr, make_namedexpr(yyvsp[-1], yyvsp[0])); ;
    break;}
case 104:
#line 419 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 105:
#line 422 "parser.y"
{ yyval = BIN(Eq, yyvsp[0], 
					   EXPR(BoolConst, (void*)0)); ;
    break;}
case 106:
#line 424 "parser.y"
{ yyval = BIN(Plus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 107:
#line 425 "parser.y"
{ yyval = BIN(Minus, yyvsp[-2], yyvsp[0]); ;
    break;}
case 108:
#line 426 "parser.y"
{ yyval = BIN(Mult, yyvsp[-2], yyvsp[0]); ;
    break;}
case 109:
#line 427 "parser.y"
{ yyval = BIN(Div, yyvsp[-2], yyvsp[0]); ;
    break;}
case 110:
#line 428 "parser.y"
{ yyval = BIN(Mod, yyvsp[-2], yyvsp[0]); ;
    break;}
case 111:
#line 429 "parser.y"
{ yyval = BIN(Lt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 112:
#line 430 "parser.y"
{ yyval = BIN(Gt, yyvsp[-2], yyvsp[0]); ;
    break;}
case 113:
#line 431 "parser.y"
{ yyval = BIN(Ge, yyvsp[-2], yyvsp[0]); ;
    break;}
case 114:
#line 432 "parser.y"
{ yyval = BIN(Le, yyvsp[-2], yyvsp[0]); ;
    break;}
case 115:
#line 433 "parser.y"
{ yyval = BIN(Eq, yyvsp[-2], yyvsp[0]); ;
    break;}
case 116:
#line 434 "parser.y"
{ yyval = BIN(Ne, yyvsp[-2], yyvsp[0]); ;
    break;}
case 117:
#line 435 "parser.y"
{ yyval = BIN(AndIf, yyvsp[-2], yyvsp[0]); ;
    break;}
case 118:
#line 436 "parser.y"
{ yyval = BIN(OrIf, yyvsp[-2], yyvsp[0]); ;
    break;}
case 119:
#line 437 "parser.y"
{ yyval = UNARY(Negate, yyvsp[0]); ;
    break;}
case 120:
#line 438 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 121:
#line 439 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 122:
#line 440 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 123:
#line 441 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 124:
#line 446 "parser.y"
{ yyval = make_int_const(yyvsp[0], make_location(&yyloc)) ;
    break;}
case 125:
#line 448 "parser.y"
{ yyval = make_float_const(yyvsp[0], make_location(&yyloc)) ;
    break;}
case 126:
#line 449 "parser.y"
{ yyval = EXPR(StringConst, yyvsp[0]); ;
    break;}
case 127:
#line 450 "parser.y"
{ yyval = EXPR(BoolConst, (void*)1); ;
    break;}
case 128:
#line 451 "parser.y"
{ yyval = EXPR(BoolConst, (void*)0); ;
    break;}
case 129:
#line 452 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 130:
#line 453 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 131:
#line 454 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 132:
#line 455 "parser.y"
{ yyval = EXPR(NullConst, NULL); ;
    break;}
case 133:
#line 457 "parser.y"
{ yyval = EXPR(DotExpr, make_sini_expr(yyvsp[0], yyvsp[-2])); ;
    break;}
case 134:
#line 462 "parser.y"
{ yyval = make_sini_expr(yyvsp[-2], yyvsp[0]); ;
    break;}
case 135:
#line 466 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 136:
#line 467 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 137:
#line 472 "parser.y"
{ yyval = EXPR(StructExpr, yyvsp[-2]) ;
    break;}
case 138:
#line 477 "parser.y"
{ yyval = EXPR(Call, P(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 139:
#line 482 "parser.y"
{ yyval = LOCATED(make_lambda(bare_fn_type(yyvsp[-4], yyvsp[-2]), yyvsp[0])); ;
    break;}
case 140:
#line 489 "parser.y"
{ yyval = STMT(Block, yyvsp[-1]); ;
    break;}
case 141:
#line 493 "parser.y"
{ yyval = nil; ;
    break;}
case 142:
#line 494 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 153:
#line 511 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-2], yyvsp[0], SKIP())); ;
    break;}
case 154:
#line 516 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-4], yyvsp[-2], yyvsp[0])); ;
    break;}
case 155:
#line 518 "parser.y"
{ yyval = STMT(If, gont_make_tuple(3, yyvsp[-4], yyvsp[-2], yyvsp[0])); ;
    break;}
case 156:
#line 522 "parser.y"
{ yyval = P(yyvsp[0], SKIP()); ;
    break;}
case 157:
#line 524 "parser.y"
{ yyval = P(yyvsp[-2], STMT(Expr, BIN(Assign,
				    EXPR(Ref, make_ref_record(yyvsp[-2])),
				    yyvsp[0]))); ;
    break;}
case 158:
#line 531 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 159:
#line 532 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 160:
#line 536 "parser.y"
{ yyval = make_vardefs(yyvsp[-1], yyvsp[0]); ;
    break;}
case 161:
#line 540 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]); ;
    break;}
case 162:
#line 541 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 163:
#line 542 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 164:
#line 543 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 165:
#line 547 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 166:
#line 548 "parser.y"
{ yyval = EXPR(BoolConst, (void*)1) ;
    break;}
case 167:
#line 552 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]) ;
    break;}
case 168:
#line 553 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 169:
#line 554 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 170:
#line 558 "parser.y"
{ yyval = empty_string; ;
    break;}
case 171:
#line 559 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 172:
#line 563 "parser.y"
{ yyval = U(SimpleName, empty_string); ;
    break;}
case 173:
#line 564 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 174:
#line 569 "parser.y"
{ yyval = LOOP(yyvsp[-5],
		     PAIR(STMT(BreakIfNot, yyvsp[-2]), yyvsp[0]),
		     SKIP()); ;
    break;}
case 175:
#line 573 "parser.y"
{ yyval = LOOP(yyvsp[-7],
		      PAIR(yyvsp[-5], STMT(BreakIfNot, yyvsp[-2])),
		      SKIP()); ;
    break;}
case 176:
#line 580 "parser.y"
{ yyval = STMT(Block, CONS(yyvsp[-6],
				  CONS(LOOP(yyvsp[-9],
					    PAIR(STMT(BreakIfNot, yyvsp[-4]), yyvsp[0]),
					    yyvsp[-2]),
				       nil))); ;
    break;}
case 177:
#line 588 "parser.y"
{ yyval = STMT(Expr, yyvsp[0]); ;
    break;}
case 178:
#line 589 "parser.y"
{ yyval = STMT(Return, EXPR(VoidConst, NULL)); ;
    break;}
case 179:
#line 590 "parser.y"
{ yyval = STMT(Return, yyvsp[0]); ;
    break;}
case 180:
#line 591 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 181:
#line 592 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 182:
#line 593 "parser.y"
{ yyval = STMT(Raise, yyvsp[0]); ;
    break;}
case 183:
#line 595 "parser.y"
{ yyval = LOCATED(make_break(U(BreakKind, NULL), yyvsp[0])); ;
    break;}
case 184:
#line 597 "parser.y"
{ yyval = LOCATED(make_break(U(ContinueKind, NULL), yyvsp[0])); ;
    break;}
case 185:
#line 601 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 186:
#line 602 "parser.y"
{ yyval = STMT(Block, CONS(STMT(Return, yyvsp[-1]), nil)); ;
    break;}
case 187:
#line 609 "parser.y"
{ yyval = P(yyvsp[-2], STMT(Block, yyvsp[0])); ;
    break;}
case 188:
#line 613 "parser.y"
{ yyval = CONS(yyvsp[-1], yyvsp[0]); ;
    break;}
case 189:
#line 614 "parser.y"
{ yyval = nil; ;
    break;}
case 190:
#line 618 "parser.y"
{ yyval = P(yyvsp[-2], yyvsp[0]); ;
    break;}
case 191:
#line 622 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 192:
#line 623 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 193:
#line 627 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 194:
#line 628 "parser.y"
{ yyval = SKIP(); ;
    break;}
case 195:
#line 632 "parser.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 196:
#line 633 "parser.y"
{ yyval = nil; ;
    break;}
case 197:
#line 638 "parser.y"
{ yyval = STMT(Try, make_try_record(yyvsp[-2], yyvsp[-1], yyvsp[0])); ;
    break;}
case 198:
#line 643 "parser.y"
{ yyval = STMT(Let, P(yyvsp[-2], yyvsp[0])); ;
    break;}
case 199:
#line 645 "parser.y"
{ yyval = STMT(Switch, P(yyvsp[-3], yyvsp[-1])); ;
    break;}
case 200:
#line 653 "parser.y"
{ yyval = CONS(yyvsp[-2], yyvsp[0]); ;
    break;}
case 201:
#line 654 "parser.y"
{ yyval = CONS(yyvsp[0], nil); ;
    break;}
case 202:
#line 658 "parser.y"
{ yyval = nil; ;
    break;}
case 203:
#line 659 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 204:
#line 663 "parser.y"
{ yyval = U(TuplePattern, yyvsp[-1]); ;
    break;}
case 205:
#line 667 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
case 206:
#line 671 "parser.y"
{ yyval = U(VoidPattern, NULL); ;
    break;}
case 207:
#line 672 "parser.y"
{ yyval = U(ExprPattern, yyvsp[0]); ;
    break;}
case 208:
#line 673 "parser.y"
{ yyval = yyvsp[0]; ;
    break;}
case 209:
#line 675 "parser.y"
{ yyval = U(UnionPattern, make_named_pattern(yyvsp[-1], yyvsp[0])); ;
    break;}
case 210:
#line 679 "parser.y"
{ yyval = LOCATED(yyvsp[0]); ;
    break;}
}

#line 705 "/usr/share/misc/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 682 "parser.y"


struct gont_union *parse(struct gont_string *file)
{
	void *lex = make_lexer(file->data);

	/* yydebug = 1; */

	if (none == NULL) {
		none = gont_make_union(GontUF_Std__None, NULL);
		nil = gont_make_union(GontUF_List__Nil, NULL);
		empty_string = gont_make_string(0, NULL);
	}

	input_filename = gont_make_string(file->len, file->data);

	if (yyparse(lex)) {
		/* We should never get here... */
		yyerror("parse error");
	}

	return decls;
}
