/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id:$
 *
 * Xobjects - .xg{o,a} save/load functions.
 */
 
open Ast;

struct xgo {
	id xgo_name;

	<id>List::t xgo_references;
	<id>List::t xgo_uses;
	
	<id>List::t xgo_used_exns;

	id xgo_init_routine;
	id xgo_fini_routine;

	bool xgo_weak;
}

struct xga {
	id xga_name;
	<xgo>List::t xga_modules;
	string xga_link_flags;
}

Xml::node serialize_xgo(xgo x);
Xml::node serialize_xga(xga x);

xgo unserialize_xgo(Xml::node n);
xga unserialize_xga(Xml::node n);

void save_xgo(xgo x, string filename);
void save_xga(xga x, string filename);
